;Konstanten:
.equ	dauerH=	240			; Teiler fr die Tondauer-Basis fr 1/16 Sekunde
.equ	dauerL= 0			; 
.equ	quite= 	0			; Pausenton zwischen Melodien
.equ	tonC2=	109			; Ton:	C
.equ	tonD2=	97			;		D
.equ 	tonE2=	87			;		E
.equ	tonF2=	82			;		F	
.equ 	tonG2=	73			;		G	
.equ	tonA2=	65			;		A
.equ	tonH2=	58			;		H
.equ	tonC3=	55			;		C
.equ	d1=		16			; Ganze Note		
.equ	d2=		8			; Halbe Note
.equ	d4=		4			; Viertel Note
.equ	d8=		2			; Achtel Note
.equ	d16=	1			; Sechzehntel Note
melodie:
	.db	d4,tonC2,d4,tonD2,d4,tonE2,d4,tonF2		; Melodie "Alle meine Entchen"
	.db d2,tonG2,d2,tonG2						; Jeder Zeit nderbar
	.db	d4,tonA2,d4,tonA2,d4,tonA2,d4,tonA2
	.db d1,tonG2
	.db d4,tonA2,d4,tonA2,d4,tonA2,d4,tonA2
	.db d1,tonG2
	.db d4,tonF2,d4,tonF2,d4,tonF2,d4,tonF2
	.db	d2,tonE2,d2,tonE2
	.db	d4,tonG2,d4,tonG2,d4,tonG2,d4,tonG2
	.db	d1,tonC2
	.db	0xFF,0xFF			; Enderkennung
;----------------------------------------------------------------------------
; r21 = aktuelle tondauer, zhlt runter
; r22 = aktuelle Frequenz, fr Counter vorbereitet
; r23 = Halbwelleninfo 0/1
; r28,r29 = Y = Zeiger auf nchsten Ton, wird jeweils in Z verschoben,
; 				da Z auch von anderen Unterprogrammen genutzt wird
;-------------------------------------------------------------------------------
;Timer-Interrupt-Hanler, Frequnz laut r22
onTC2:	cli								; Interrups sperren
		in  	save_sreg, SREG			; SREG sichern
		push	r16						; r16 sichern
		ldi		r16, quite				; lade Ton in r16
		cpse	r22, r16				; kein wechsel bei "quite"
		;-- Bit-Status Wechsel n Port B = Halbwelle
		sbis	PORTB, 5				; Bit 5 von PortB mit 1 vergleichen
		rjmp	onTC2_1					; wenn nicht gleich dann spring zu onTC2_1
		cbi		PORTB, 5				; wenn gleich dann setzte 0
		rjmp	onTC2_2					; spring zu onTC2_2
onTC2_1:sbi		PORTB, 5				; setzte Bit 5
onTC2_2:;-- Counter neu laden
		out		TCNT2, r22				; Timer2-Counter-Reinit
		;--ende
		pop		r16						; r16 wiederherstellen
		out  	SREG, save_sreg			; SREG wiederherstellen
		sei								; Interrups freigeben
		reti							; Rcksprung
;--------------------------------------------------------------------------------
;Timer-Interrupt-Handlr fr die Tondauer, zhlt r21 runter
onTC1: 	cli								; Interrups sperren
		in  	save_sreg, SREG			; SREG sichern
		push	r16						; r16 sichern
		ldi		r16, dauerH				; Timer - Init
		out		TCNT1H, r16
		ldi		r16, dauerL
		out		TCNT1L, r16
		;---- Ende Timer-Init ---
		dec		r21						; Dekrementiere r21
		brne	onTC1ende				; noch nicht Null -> weiter warten
		;---- wenn Tonpause war -> nchsten Ton laden ---
		cpi		r22, quite				; Tonpause?
		breq	nextTon					; Wenn vorbei, nchster Ton laden
		;---- Tonpause ---
		ldi		r22, quite				; Tonpause laden
		ldi		r21, 1					
		rjmp	onTC1ende
nextTon:								;-------nchster Ton laden ---
		mov		r30, r28				; Adresse laden
		mov		r31, r29				; 		"
		lpm		r21, Z+					; Tondauer
		lpm		r22, Z					; Tonfrequenz
		adiw	r28, 2					; Adresse fr nchste Note laen
		cpi		r21, 0xFF				; Teste ob Ende
		brne	onTC1ende				; Wenn ja, von vorne
;--- Melodie auf Anfang
		ldi		r28, low(melodie*2)		; Low Teil in Y
		ldi		r29, high(melodie*2)	; High Teil in Y
		ldi		r21, d1		
		ldi		r22, quite				; Pause laden
onTC1ende:
		pop		r16						; r16 wiederherstellen
		out  	SREG, save_sreg			; SREG wiederherstellen
		sei								; Interrups freigeben
		reti							; Rcksprung
;----------------------------------------------------------------
; Vergleicht aktuelle Uhrzeit mit der Weckzeit
; PE: r30,r31 Adresse
;----------------------------------------------------------
comp_alarm:	push	r15				; register sichern
			push	r16				
			push	r17				
			push	r18	
			push	r24
			push	r25
			mov		r16, alarm_activ
			sbrs	r16, 0
			rjmp	comp_alarm_end
			rcall	getSecond		; Sekunden auslesen
			push	r16				; sichern
			rcall	getMinute		; Minuten auslesen
			push	r16				; sichern
			rcall	getHour			; Studnen auslesen
			push	r16				; sichern
			lpm		r24, Z+			; Adresse EEPROM laden
			lpm		r25, Z
			rcall	EERead			; Vergleichswert fr Stunden aus EEPROM lesen
			mov		r16, r18		; Wert in r16 verschieben
			adiw	r24, 1			; Adress um 1 erhhen
			rcall	EERead			; Vergleichswert fr Minuten laden
			mov		r17, r18		; min = r17
			adiw	r24, 1			; 1 erhhen
			rcall	EERead			; Wert fr Sekunden laden
			pop		r15				; Stunden holen
			cp		r15, r16		; Stunden vergleichen
			pop		r15				; Miunten holen
			cpc		r15, r17		; Minuten vergleichen
			pop		r15				; Sekunden holen
			cpc		r15, r18		; Sekunden vergleichen
			brne	comp_alarm_end	; wenn nicht gleich -> ende
			rcall	alarm			; wenn gleich ( alle 3 gleich) Alarm auslsen
comp_alarm_end:
			pop		r25				; register wiederherstellen
			pop		r24
			pop		r18
			pop		r17
			pop		r16
			pop		r15
			ret						; Rcksprung
;---------------------------------------------------------------
; Lst Alarm aus indem Timer aktiviert werden
;----------------------------------------------------------
alarm:		push	r16				; Register sichern
			ldi		r16, 0b00000011	; Vorteiler
			out		TCCR1B, r16		; schreiben
			out		TCCR2, r16		; schreiben
			pop		r16				; Register wiederherstellen
			ret						; Rcksprung
;--------------------------------------------------------------
; Stoppt Alarm indem Timer deaktiviert werden
;--------------------------------------------------
clear_alarm:
			push	r16				; Register sichern
			ldi		r16, 0b00000000	; Timer
			out		TCCR2, r16		; deaktivieren
			out		TCCR1B, r16		; deaktivieren
			ldi		r23, 0			; Halbwelleninfo
			ldi		r22, quite		; Frequenz
			ldi		r21, d16		; Dauer bis es losgeht
			;-- Melodie auf Anfang ---
			ldi		r28, low(melodie*2)	; Low Teil in Y
			ldi		r29, high(melodie*2); High Teil in Y
			pop		r16				; Register wiederherstellen
			ret						; Rcksprung
;--------------------------------------------------------------
; Daten in EEPROM schreiben r24, r25 = Adresse, r18 = data byte
;-----------------------------------------------------------------
EEWrite:	out		EEARH, r25			; Adresse
			out		EEARL, r24			; Adresse
			out		EEDR, r18			; Daten bergeben
			sbi		EECR, 2				; Schreiben erlauben
			sbi		EECR, 1				; Schreibaufforderung						
waitEEW:	sbic	EECR, 1				; warte auf Fertigmeldung des EEPROM
			rjmp	waitEEW
			ret							; Rcksprung
;---------------------------------------------------------------------------
; aus EEPROM lesen r24,r25 = Adresse, r18 = result data byte
;----------------------------------------------------------------------
EERead:		out		EEARH, r25			; Adresse
			out		EEARL, r24			; Adresse
			sbi		EECR, 0				; Leseaufforderung
waitEER:	sbic	EECR, 0				; warte auf Fertigmeldung
			rjmp	waitEER				
			in		r18, EEDR			; Daten bernehmen
			ret							; Rcksprung
;-------------------------------------------------------------------
