lcd_out:	rcall	LCD_home			; 1. Zeile 1. Zeichen springen
			rcall	out_alarm			; gibt 'x' aus wenn Alarm aktiv und ' ' wenn deaktiv
			ldi		r16,' '				; Leerzeichen senden
			rcall	LCD_data
			rcall	sendDay				; Wochentag senden
			ldi		r16,' '				; ; Leerzeichen senden
			rcall	LCD_data
			ldi		r16,' '
			rcall	LCD_data			 
			rcall	sendDate			; Datum senden
			rcall	LCD_line2			; 2. Zeile
			rcall	sendTemp			; Temperatur senden
			ldi		r16,' '				; Leerzeichen
			rcall	LCD_data			; senden
			rcall	send_time			; Uhrzeit senden
			ret							; Rcksprung
;----------------------------------------------------------------------------
; sendet die Temperatur
; Keine Registervernderung
;----------------------------------------------------------------------
sendTemp:	push	r16					; Register sichern
			push	r17
			push	r18
			rcall	getTemp				; Temperatur von Sensor laden r16 = Temp HIGH, r17 = Temp LOW
			push	r17					; Temp LOW sichern
			sbrs	r16,7				; wenn positiv
			rjmp	ascii				; dann spring zu ascii:
			neg		r16					; sonst 2. Complement 
			push	r16					; temp HIGH sichern
			ldi		r16,'-'				; Minuszeichen laden
			mov		r30,r16				; sichern
			rcall	LCD_data			; senden
			pop		r16					; temp HIGH wieder herstellen
ascii:		rcall	reg8ToAscii			; temp HIGH in ASCII-Code umwandeln r16=Hunderter, r17=Zehner, r18=Einer
			cpi		r30,'-'				; wenn negativ
			breq	zehn				; dann => zehn
			cpi		r16,'0'				; wenn nicht Null
			brne	outHundert			; Hunderter ausgeben
			ldi		r16,' '				; sonst nichts ausgeben
outHundert:	rcall	LCD_data			; Senden
zehn:		mov		r16,r17				; Zehner laden
			cpi		r16,'0'				; wenn nicht Null
			brne	outZehn				; Zehner ausgeben
			ldi		r16,' '				; sonst nichts ausgeben
outZehn:	rcall	LCD_data			; Senden
			mov		r16,r18				; Einer laden
			rcall	LCD_data			; Senden
			ldi		r16,','				; Komma laden
			rcall	LCD_data			; Senden
			pop		r17					; Temp LOW wieder herstellen
			bst		r17,7				; Bit in T-Flag speichern
			brts	komma5				; wenn T gesetzt dann Komma 5
			ldi		r16,'0'				; sonst Null
			rjmp	outKomma			; zur Ausgabe springen
komma5:		ldi		r16, '5'			; 5 laden
outKomma:	rcall	LCD_data			; 0 oder 5 ausgeben
			ldi		r16,0b11011111		;  (Grad) laden
			rcall	LCD_data			; Senden
			ldi		r16,'C'				; C (Celcius) laden
			rcall	LCD_data			; Senden
			pop		r18					; Register wieder herstellen
			pop		r17				
			pop		r16
			ret							; Rcksprung
;------------------------------------------------------------------			
; sendDay1: sendet den Wochentag
; PE: r16 = Tag (ohne getDay)						
;-------------------------
; sendDay:	sendet den Wochentag 
;-------------------------------------------------------------------------------
sendDay:	rcall	getDay			; Tag von der RTC holen in r16
sendDay1:	push	r17				; r17 sichern
			ldi		r30, low(day)	; Zeiger auf
			ldi		r31, high(day)	; Sprungtabelle
			dec		r16				; Tag
			add		r30,r16			; Tag
			ldi		r16,0
			adc		r31,r16			; addieren
			ijmp					; Tag aufrufen
day:		rjmp	mo				; Springe
			rjmp	di				; zu
			rjmp	mi				; Tag
			rjmp	do
			rjmp	fr
			rjmp	sa
			rjmp	so
mo:			ldi		r16,'M'
			ldi		r17,'o'
			rjmp	outday
di:			ldi		r16,'D'
			ldi		r17,'i'
			rjmp	outday			
mi:   		ldi		r16,'M'
			ldi		r17,'i'
			rjmp	outday
do:			ldi		r16,'D'
			ldi		r17,'o'
			rjmp	outday
fr:			ldi		r16,'F'
			ldi		r17,'r'
			rjmp	outday
sa:			ldi		r16,'S'
			ldi		r17,'a'
			rjmp	outday
so:			ldi		r16,'S'
			ldi		r17,'o'
outday:		rcall	LCD_data		; Tag senden
			mov		r16,r17			; 2. Buchstabe laden
			rcall	LCD_data		; senden
			pop		r17				; r17 wiederherstellen
			ret						; Rcksprung
;-------------------------------------------------------------------------------
; sendet das Datum
; keine Registernderung
;----------------------------------------------------------------------------------
sendDate:	push	r16				; r16 sichern
			rcall	getDate			; Tag laden
			rcall	sendBCD			; senden
			ldi		r16,'.'			; Trennzeichen
			rcall	LCD_data		; senden
			rcall	getMonth		; Monat laden
			rcall	sendBCD			; senden
			ldi		r16,'.'			; Trennzeichen
			rcall	LCD_data		; senden
			ldi		r16,'2'			; 2	(1. Ziffer frs Jahr)
			rcall	LCD_data		; senden
			ldi		r16,'0'			; 0	(2. Ziffer frs Jahr)
			rcall	LCD_data		; senden
			rcall	getYear			; letzten beiden Ziffern frs Jahr laden
			rcall	sendBCD			; senden
			pop		r16				; r16 wiederherstellen
			ret						; Rcksprung
;--------------------------------------------------------------------------------
; sendet die Uhrzeit
; keine Registernderung
;----------------------------------------------------------------
send_time:	push	r16				; r16 sichern
			rcall	getHour			; Stunden laden
			rcall	sendBCD			; senden
			ldi		r16,':'			; Trennzeichen
			rcall	LCD_data		; senden
			rcall	getMinute		; Minuten laden
			rcall	sendBCD			; senden
			ldi		r16,':'			; Trennzeichen
			rcall	LCD_data		; senden
			rcall	getSecond		; Sekunden laden
			rcall	sendBCD			; senden
			pop		r16				; r16 wiederherstellen
			ret						; Rcksprung
;-------------------------------------------------------------------------------
; sendet Text von Programmspeicher
; PE: r30 , r31 = Adresse
;---------------------------------------------------------
send_text:	push	r16
send_text1:	lpm		r16, Z+				; Zeichen vom Programmspeicher laden und Adresse erhhen
			tst		r16					; auf 0 prfen
			breq	send_text_end		; wenn 0 dann ende
			rcall	LCD_data			; sonst Zeichen senden
			rjmp	send_text1			; nchstes Zeichen
send_text_end:
			pop		r16
			ret
;-------------------------------------------------------------------------------
; gibt 'x' aus wenn alarm aktiv und ' ' wenn deaktiv
out_alarm:	push	r16					; r16 sichern
			mov		r16, alarm_activ	; in r16 laden 
			sbrs	r16, 0				; wenn nicht gesetzt
			ldi		r16, ' '			; dann ' '
			sbrc	r16, 0				; wenn gesetzt
			ldi		r16, 'x'			; dann 'x'
			rcall	LCD_data			; senden
			pop		r16					; r16 wieder herstellen
			ret							; Rcksprung
;---------------------------------------------------------------------------------
