;-------------------------------------------------------------------------------
init_RTC:	; RTC startet wenn nicht luft
			push	r16
			push	r20
			ldi		r16,0
			rcall	getRtcData
			andi	r16,0x80
			breq	rtcIsOn
			; -- Bit 7 in Sekunden = 0
			;-> RTC ON
			rcall	twiStart
			ldi		r16,RTC_ADR|TWI_WRITE
			ldi		r20,0				; kein ACKN
			rcall	twiWriteByte		; Daten schreiben
			ldi		r16,0				; Sekunden adressieren
			ldi		r20,0				; kein ACKN
			rcall	twiWriteByte		; Daten schreiben
			ldi		r16,0				; Bit7=0 = Start
			ldi		r20,0				; kein ACKN
			rcall	twiWriteByte		; Daten schreiben
			rcall	twiStop				; TWI beenden
rtcIsOn:	pop		r20
			pop		r16
			ret
;--------------------------------------------------------------------------
; fragt nach den aktuellen Daten von der RTC
; PA: r16 = Daten
;----------------------------------------------------------------------------
getSecond:	ldi		r16,0			; Sekunden
			rcall	getRtcData
			andi	r16,0x7f		; da Bit 7 nicht zu den Sekunden zhlt
			ret
;---------------------------------------------------------------------------
getMinute:	ldi		r16,1			; Minuten
			rcall	getRtcData	
			ret
;------------------------------------------------------------------------
getHour:	ldi		r16,2			; Stunden
			rcall	getRtcData
			andi	r16,0x3f		; da Bit 6, 7 nicht zu den Stunden zhlt
			ret
;-----------------------------------------------------------------------
getDay:		ldi		r16,3			; Wochentag
			rcall	getRtcData
			ret
;------------------------------------------------------------------------
getDate:	ldi		r16,4			; Tag im Monat
			rcall	getRtcData
			ret
;------------------------------------------------------------------------
getMonth:	ldi		r16,5			; Monat
			rcall	getRtcData
			ret
;------------------------------------------------------------------------
getYear:	ldi		r16,6			; Jahr
			rcall	getRtcData
			ret
;------------------------------------------------------------------------
; getRtcData
; PE: r16 = Adresse
; PA: r16 = Daten
;-------------------------------------------------------------------------
getRtcData:	push	r20
			push	r16
			; -- Adresse senden
			rcall	twiStart
			ldi		r16,RTC_ADR|TWI_WRITE
			ldi		r20,0			; kein ACKN
			rcall	twiWriteByte
			pop 	r16				; Adresse
			ldi		r20,0			; kein ACKN
			rcall	twiWriteByte
			; -- Daten lesen
			rcall	twiStart
			ldi		r16,RTC_ADR|TWI_READ
			rcall	twiWriteByte	; Daten schreiben
			ldi		r20,0			; kain ACKN
			rcall	twiReadByte		; Daten lesen
			rcall	twiStop			; Twi beenden
			pop		r20
			ret
;----------------------------------------------------------------------
; setzt Daten in der RTC
; PE: r16 = Daten
;-----------------------------------------------------------------------
putSecond:	ldi		r17, 0				; Adresse
			andi	r16, 0b01111111		; RTC aktivieren
			rcall	putRtcData			; Daten schreiben
			ret							; Rcksprung
;--------------------------------------------------------------------------
putMinute:	ldi		r17, 1				; Adresse
			rcall	putRtcData			; Daten schreiben
			ret							; Rcksprung
;--------------------------------------------------------------------------
putHour:	ldi		r17, 2		   		; Adresse
			andi	r16, 0b00111111		; 24 Stunden-Modus
			rcall	putRtcData			; Daten schreiben
			ret							; Rcksprung
;--------------------------------------------------------------------------
putDay:		ldi		r17, 3				; Adresse
			rcall	putRtcData			; Daten schreiben
			ret							; Rcksprung
;--------------------------------------------------------------------------
putDate:	ldi		r17, 4				; Adresse
			rcall	putRtcData			; Daten schreiben
			ret							; Rcksprung
;--------------------------------------------------------------------------
putMonth:	ldi		r17, 5				; Adresse
			rcall	putRtcData			; Daten schreiben
			ret							; Rcksprung
;--------------------------------------------------------------------------
putYear:	ldi		r17, 6				; Adresse
			rcall	putRtcData			; Daten schreiben
			ret							; Rcksprung
;--------------------------------------------------------------------------
; putRtcData
; PE: r16 = Daten, r17 = Adresse
;------------------------------------------------------------------------------------
putRtcData:	push	r20
			push	r16
			; -- Adresse senden
			rcall	twiStart
			ldi		r16, RTC_ADR|TWI_WRITE
			ldi		r20, 0
			rcall	twiWriteByte
			mov		r16, r17
			ldi		r20, 0
			rcall	twiWriteByte
			; -- Daten schreiben
			pop		r16
			ldi		r20, 0
			rcall	twiWriteByte
			rcall	twiStop
			pop		r20
			ret
;----------------------------------------
