;--------------------------------------------------------------------
.equ		REG_TEMP=0b00000000
.equ		REG_CONFIG=0b00000001
.equ		REG_HYST=0b00000010
.equ		REG_SET=0b00000011
;----------------------------------------------------------------------
; UP:		init_LM75
; Config = NoShutdown, ComperatorMode,ActiveLow,FaultQueue=0
;---------------------------------------------------------------------
init_LM75:	push	r16
			push	r17
			push	r18
			ldi		r16,0
			ldi		r17,0
			ldi		r18,REG_CONFIG
			rcall	setRegisterLM75
			; Comperator-PIN schalten z.B. bei 25C
			; Hysterese = Ausschalttemperatur
			ldi		r16,0
			ldi		r17,30
			ldi		r18,REG_HYST
			rcall	setRegisterLM75
			; SET = Einschalttemperatur
			ldi		r16,0
			ldi		r17,30
			ldi		r18,REG_SET
			rcall	setRegisterLM75
			pop		r18
			pop		r17
			pop		r16
			ret
;-------------------------------------------------------------------------
; PA. r16 = TempHigh (bit0-7)
;	  r17 = TempLow	(bit7)
;------------------------------------------------------------------------
getTemp:	push 	r20
			;--Adresse senden
			rcall	twiStart
			ldi		r16,LM75_ADR|TWI_WRITE
			ldi		r20,0					; kein ACK
			rcall	twiWriteByte
			ldi		r16,REG_TEMP			; adressieren
			ldi		r20,0					; kein ACK
			rcall	twiWriteByte			; schreiben
			;--- Lesezyklus
			rcall	twiStart				; TWI starten
			ldi		r16,LM75_ADR|TWI_READ
			ldi		r20,0b00000001			; TWEA = ACK
			rcall	twiWriteByte			; schreiben
			ldi		r20,0b0000001			; TWEA = ACK
			rcall	twiReadByte				; Daten lesen = HighData
			push	r16
			ldi		r20,0					; kein ACk
			rcall	twiReadByte				; Daten lesen = LowData
			mov		r17,r16
			rcall	twiStop
			pop		r16
			pop		r20
			ret
;--------------------------------------------------------------------------
; setRegisterLM75 - schreibt ein Register des LM75
; PE r16 = WertLow
;	 r17 = Wert High
;    r18 = Registeer: REG_CONFIG,REG_HYST,REG_SET
;----------------------------------------------------------------------------------
setRegisterLM75:
			push	r16
			rcall	twiStart
			;Adress senden
			ldi		r16,LM75_ADR|TWI_WRITE
			ldi		r20,0			; kein ACKN
			rcall	twiWriteByte
			;Register adressieren
			mov		r16,r18
			ldi		r20,0			; kein ACKN
			rcall	twiWriteByte
			;Wert schreiben
			mov		r16,r17
			ldi		r20,0			; kein ACKN
			rcall	twiWriteByte
			;Wert schreiben
			pop 	r16
			ldi		r20,0			; kein ACKN
			rcall	twiWriteByte
			rcall	twiStop
			ret
;------------------------------------------------------------------------------------
