;--------------------------------------------------------------------------------
.equ		TWI_CLOCK=100000 ; Geschwindigkeit des TWI-Busses
.equ		TWI_READ=0b00000001
.equ		TWI_WRITE=0b00000000
;-----------------------------------------------------------------------------------
; TWCR - Control-Register-Bits
.equ		_TWINT=0b10000000
.equ		_TWEA=0b01000000
.equ		_TWSTA=0b00100000
.equ		_TWSTO=0b00010000
.equ		_TWWC=0b00001000
.equ		_TWEN=0b00000100
.equ		_TWIE=0b00000001
;-----------------------------------------------------------------------------------
; twiInitMaster (ohne Interrupt)
; gestattet die Benutzng von TWI und setzt die Master-Clock-Rate
.equ		TWI_ADR=0x00
;----------------------------------------------------------------------------------
twiInitMaster:
	push	r16
	; Clock
	ldi	r16,((F_CPU/TWI_CLOCK)-16)/2
	out	TWBR,r16
	;TWI-Status-Register (Vorteiler)
	ldi	r16,0
	out	TWSR,r16
	; Bus-Addr
	ldi	r16,TWI_ADR
	out	TWAR,r16
	; Enable
	ldi	r16,_TWINT|_TWEN
	out	TWCR,r16
	pop	r16
	ret
;------------------------------------------------------------------------
; Start TWI
;------------------------------------------------------------------------
twiStart:
	push	r16
	ldi		r16,0b10100100		; TWINT | TWSTA | TWEN
	out		TWCR,r16
TWI_Start_wait1:
	in		r16,TWCR
	sbrs	r16,7				; TWINT
	rjmp	TWI_Start_wait1
	pop		r16
	ret
;------------------------------------------------------------------------
; Stopp TWI
;------------------------------------------------------------------------
twiStop:
	push	r16
	in		r16,TWCR
	andi	r16,_TWEN|_TWIE	; nur Beibehalten von Enable und InterruptJ/N
	ori		r16,_TWINT|_TWSTO
	out		TWCR,r16
	pop		r16
	ret
;------------------------------------------------------------------------
; Write Byte per TWI (ohne Interrupt)
; PE: r16 = Data
;     r20.0 = 1 -> Acknowledge (=TWEA) setzten fr Datenanforderung
;------------------------------------------------------------------------
twiWriteByte:
	push	r16
	out		TWDR,r16	; Daten bereitlegen
	in		r16,TWCR
	andi	r16,_TWEN|_TWIE	; nur Beibehalten von Enable und InterruptJ/N
	ori		r16,_TWINT
	sbrc	r20,0
	ori		r16,_TWEA	; evt. TWEA setzen, fr Datenanforderung
	out		TWCR,r16	; senden
twiWriteByte_wait2:
	in		r16,TWCR
	sbrs	r16,7	; TWINT
	rjmp	twiWriteByte_wait2	;-> warten, wenn noch nicht weg
	pop	r16
	ret
;------------------------------------------------------------------------
; Read Byte per TWI (ohne Interrupt)
; PE: r20.0 = 1 -> Acknowledge (=TWEA) setzten fr Datenanforderung
; PA: r16 = Data
;------------------------------------------------------------------------
twiReadByte:
	in	r16,TWCR
	andi	r16,_TWEN|_TWIE
	ori	r16,_TWINT
	sbrc	r20,0
	ori	r16,_TWEA	; evt. TWEA setzen, fr Datenanforderung
	out	TWCR,r16
twiReadByte_wait2:
	in	r16,TWCR
	sbrs	r16,7	; TWINT
	rjmp	twiReadByte_wait2
	in	r16,TWDR
	ret
;-------------------------------------------------------------
