;-----------------------------------------------------------------------------------
; Wait_ms - Warte-Routine fr x-Millisekunden
; ein Millisekundenzyklus dauert 1,052 ms
; PE: r16 = Anzahl der zu wartenden Millisekunden
; PA: r16 = 0
;--------------------------------------------------------------------
Wait_ms:	push 	r16
 			ldi 	r16,1
Wait_ms_3:	push 	r16
 			ldi 	r16,5
Wait_ms_2:	push 	r16
 			ldi		r16,255
Wait_ms_1:	dec		r16 
 			brne	Wait_ms_1
 			pop 	r16
 			dec 	r16 
 			brne 	Wait_ms_2
 			pop 	r16
 			dec 	r16 
 			brne 	Wait_ms_3
 			pop 	r16
 			dec	 	r16 
 			brne 	Wait_ms
 			ret
;--------------------------------------------------------------------
; Wait_10us - Warte-Routine fr 10x-Mikrosenden
; zehn Millisekunden dauern 10,04 s
; PE: r16 = Anzahl der zu wartenden 10 Mikrosekunden
; PA: r16 = 0
;--------------------------------------------------------------------
Wait_10us:	push 	r16
 			ldi 	r16,1
Wait_10us_3:push 	r16
 			ldi 	r16,1
Wait_10us_2:push 	r16
 			ldi 	r16,4
Wait_10us_1:dec 	r16 
 			brne 	Wait_10us_1
 			pop 	r16
 			dec 	r16 
 			brne 	Wait_10us_2
			pop 	r16
 			dec 	r16 
 			brne	Wait_10us_3
 			pop 	r16
			dec 	r16
			brne 	Wait_10us
 			ret

;---------------------------------------------------------------------------------
; UP:		reg8ToAscii, wandelt einen 8-Bit Wert in ASCII Dez Code um
; PE:		r16
; PA:		r16,r17,r18
;----------------------------------------------------------------------------------
reg8ToAscii:
			push	r6
			push	r19
			ldi		r17,100			; durch 100 dividieren
			rcall	div8int
			mov		r6,r16			; erste Stelle merken
			mov		r16,r17			; mit dem Rest weitermachen#
			ldi		r17,10			; durch	10 dividieren
			rcall	div8int			
			mov		r18,r17			; Rest = 1er
			mov		r17,r16			; Ergebnis = 10er
			mov		r16,r6			; Gemerktes = 100er
			; Wandlung in ASCII
			ldi		r19,48
			add		r16,r19
			add		r17,r19
			add		r18,r19
			pop		r19
			pop		r6
			ret
;-----------------------------------------------------------------------------------
; PU:		div8int, 8Bit-Integer-Division
; PE:		r16:r17
; PA:		r16=Ergebnis, r17=Rest
;-----------------------------------------------------------------------------------
div8int:	push	r18
			mov		r18,r17			; r18 = divisor
			mov		r17,r16			; r17 = Rest
			ldi		r16,0			; r16 = Ergebnis
			cpi		r18,0
			breq	div8int_2
div8int_1:	cp		r17,r18
			brcs	div8int_2
			sub		r17,r18
			inc		r16
			rjmp	div8int_1
div8int_2:	pop		r18
			ret
;-------------------------------------------------------------------------------------------------
; Inkrementiert ein packed BCD
; PE: r17 = BCD
; PA: r17 = BCD +1 
;------------------------------------------------------------------------------------------------
BCD_inc:	push	r16					; Register sichern
			inc 	r17					; +1
			mov		r16, r17
			andi	r16, 0x0F			; nur untere Hlfte
			cpi		r16, 10				; wenn kleiner 10
			brlo	BCD_inc_end			; dann ende
			ldi		r16, 6				; sonst
			add		r17, r16			; 6 addieren
BCD_inc_end:
			pop		r16					; Register wiederherstellen
			ret							; Rcksprung
;------------------------------------------------------------------






